uniform vec4 addedColor;
uniform float rgbIntensity;

vec4 normalizeColor(vec4 color)
{
    float m = max(max(color.r, color.g), max(color.b, 0.01));
    return vec4(color.rgb / m, color.a);
}

float ramp(float val)
{
    return sin( val * 1.35 ) / 0.9757;
}

void main()
{
    vec4 base = gl_Color;
    vec4 color = normalizeColor( vec4( base.rgb * rgbIntensity + addedColor.rgb, 1.0 ) );
    color.r = ramp( color.r );
    color.g = ramp( color.g );
    color.b = ramp( color.b );
    gl_FragColor = color;
}
