uniform float rgbIntensity;

vec4 normalizeColor(vec4 color)
{
    float m = max(max(color.r, color.g), max(color.b, 0.01));
    return vec4(color.rgb * rgbIntensity / m, color.a);
}

void main()
{
    vec4 base = normalizeColor( gl_Color );
    vec4 color = vec4( base.rgb * rgbIntensity, 1.0 );
    gl_FragColor = normalizeColor(color);
}
